<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>ITEA-JS ADVANCED - LESSON 2: CLASSWORK 2</title>
  <link rel="stylesheet" href="css/style.min.css" />
</head>
<body>
  <div class="wrap">
    <div class="testBlock hover">
      <button class="iButton" id="mouseHover">Наведи</button>
      <ul id="hoverResult" class="resultBlock">
        <!-- <li class="red">Hovered!</li>
        <li class="blue">Hovered!</li>
        <li class="orange">Hovered!</li>
        <li class="red">Hovered!</li>
        <li class="red">Hovered!</li> -->
      </ul>
    </div>

    <div class="testBlock click">
      <button class="iButton" id="mouseClick">Нажми правой кнопкой мышки</button>
      <div id="clickResult" class="resultBlock one two three four five six"></div>
    </div>

    <div class="testBlock context">
      <button class="iButton" id="mouseContext">Вызови контекстное меню</button>
      <div id="contextResult" class="resultBlock"></div>
    </div>

    <div class="testBlock keyboard">
      <button class="iButton" id="keyboardButton">Нажми на клавиатуре</button>
      <div id="keyboardResult" class="resultBlock"></div>
    </div>

  </div>

  <script>
    /*

      Поработаем немного с ивентами:
      onmouseenter
      onclick
      oncontextmenu
      onkeydown

      Задание:
      На каждую из конопок назначить действие которое будет выполнять следующее действие:
      1.На ховер(onmouseenter) повесить обработчик который будет при каждом наведении
        на кнопку будет выводить в блок результатом елемент li с текстом "hovered!"
        у которого будет один из следующих класов:
        red blue green orange purple

      2.На кнопку клика(onclick) повесить обработчик который будет удалять классы с
        блока с результатом по очереди в таком порядке:

        six > two > three > four > one > five

        после того как блок окажется пустым, добавить их в порядке возрастания

        one > two > three ... > six

      3.На кнопку контекстного меню (oncontextmenu) повесить обработчик который в блок
        для результата выведет блок со списком меню используя следующий шаблон:

        <a href="http://google.com.ua">Google</a>
        <a href="http://itea.ua/">ITEA</a>
        <a href="https://www.youtube.com/">Youtube</a>

        для запрета вызова контектстного меню, нужно в функцию обработчик передать событие
        element.onevent = function(e){...}
        и вызвать внутри этой функции из этой переменной
        e.preventDefault(); <- Отмена действия по умолчанию

        Повтороное кажатие на эту кнопку правой или левой кнопкой мыши должно очистить блок.

      4. На кнопку с обработчиком нажатия (onkeydown) повесить обработчик который будет
        Выводить число нажатий на любую из клавиш клавиатуры


    */
    mouseHover.onmouseenter = function(){
      var ul = document.getElementById('hoverResult');
      var li = document.createElement('li');
          li.innerText = "hovered!";

      var colors_array = ["red","blue","green","orange","purple"];
      var rand = Math.floor(Math.random() * colors_array.length);

      li.className = colors_array[rand];
      ul.appendChild(li);  

    
      console.log('hover');

    }

    var clickIndex = 0;
    var direction = true;

    function addOrRemove(custom_direction, method, clickIndex) {
      var clickResult = document.getElementById('clickResult');
      var array;
      if( method === 'remove'){
        array = ["one", "two", "three", "four", "five", "six"];
      } else {
        array = ["six", "two", "three", "four", "one", "five"];
      }
      
      console.log( custom_direction, method, array[clickIndex], clickIndex );

          if (method === 'add') {
             if (clickIndex === 5) {
                clickResult.classList.remove(array[clickIndex]);
                direction = !custom_direction;
                clickIndex = 0;
                return clickIndex;
             } else {
                clickResult.classList.remove(array[clickIndex]);
                clickIndex++;
                return clickIndex;
             }
          } else {
            if (clickIndex === 5) {
              clickResult.classList.add(array[clickIndex]);
              direction = !custom_direction;
              clickIndex = 0;
              return clickIndex;
            } else {
              clickResult.classList.add(array[clickIndex]);
              clickIndex++;
              return clickIndex;
            }
          }
      }

    mouseClick.onclick = function(){
      if(direction){
          clickIndex = addOrRemove( true, 'add', clickIndex );
      } else {
          clickIndex = addOrRemove( false, 'remove', clickIndex);
      }
      
    }
  
    mouseContext.oncontextmenu = function(e){
      if(e){
        e.preventDefault();
      }
       var Result = document.getElementById('contextResult');

      if (!Result.children.length) {
      var ul = document.createElement('ul');
      var blockli_s = {
        'Google': '"http://google.com.ua',
        'ITEA': 'http://itea.ua/',
        'Youtube': 'https://www.youtube.com/',
      };
      for(var property in blockli_s){
        var li = document.createElement('li');
        var a = document.createElement('a');
        a.href = blockli_s[property];
        a.innerText = property;
        li.appendChild(a);
        ul.appendChild(li);
      }
      Result.appendChild(ul);
    } else {
      var ul = Result.firstChild;
        ul.remove();
      }
    }
    
    var keydowns = 0;
    keyboardButton.onkeydown = function(){
    
    keydowns++;

    var rslt = document.getElementById('keyboardResult')
     
      if(keydowns){
        rslt.innerText = keydowns;
       
      }
      console.log('keyboard');
    }
  </script>
</body>
</html>
